 /*
  * Khoros: $Id: meigen.h,v 1.3 1992/03/20 23:44:43 dkhoros Exp $
  */

 /*
  * $Log: meigen.h,v $
 * Revision 1.3  1992/03/20  23:44:43  dkhoros
 * VirtualPatch5
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1992, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1992 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: meigen.h
 >>>>            Author: Jeremy Worley
 >>>> Date Last Updated: Thu Mar  5 08:57:26 1992
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _meigen_h_
#define _meigen_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    meigen Argument Structure
*
****************************************************************/

typedef struct _meigen  {

/*
 *  input file (matrix file) (Required infile)
 */
char	*i_file;	/* input file (matrix file) FILENAME */
int	 i_flag;	/* input file (matrix file) FLAG */

/*
 *  resulting eigenvector output file (matrix file) (Optional outfile)
 */
char	*o1_file;	/* resulting eigenvector output file (matrix file) FILENAME */
int	 o1_flag;	/* resulting eigenvector output file (matrix file) FLAG */

/*
 *  resulting eigenvalue output file (matrix file) (Optional outfile)
 */
char	*o2_file;	/* resulting eigenvalue output file (matrix file) FILENAME */
int	 o2_flag;	/* resulting eigenvalue output file (matrix file) FLAG */

/*
 *  define arithmetic on data (Optional logical)
 */
int	 j_logic;	/* define arithmetic on data LOGIC */
int	 j_flag;  	/* define arithmetic on data FLAG */

}  meigen_struct;

meigen_struct *meigen;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
